<template>
  <div class="vote" :key="voteStatus.status">
    <h1 class="title is-4">{{localVoteCount}} votes</h1>
    <div v-if="voteStatus.status === 'none'">
      <b-button size="is-small" icon-left="thumb-down-outline" style="top:-2px" @click="addDownVote"/>
      <b-button size="is-small" icon-left="thumb-up-outline" style="top:-2px" @click="addUpVote"/>
    </div>
    <div v-else-if="voteStatus.status === 'up'">
      <b-button size="is-small" icon-left="thumb-down-outline" style="top:-2px" disabled/>
      <b-button size="is-small" icon-left="thumb-up" style="top:-2px" @click="removeUpVote" type="is-success"/>
    </div>
    <div v-else-if="voteStatus.status === 'down'">
      <b-button size="is-small" icon-left="thumb-down" style="top:-2px" @click="removeDownVote" type="is-danger"/>
      <b-button size="is-small" icon-left="thumb-up-outline" style="top:-2px" disabled/>
    </div>
  </div>
</template>

<script>
import { api } from '@/api.js'

export default {
  name: 'vote',
  props: ['modelId', 'voteCount'],
  data () {
    return {
      voteStatus: {
        status: 'none'
      },
      localVoteCount: 0
    }
  },
  async mounted () {
    this.localVoteCount = this.voteCount
    this.voteStatus = await api.getVoteStatus(this.modelId)
  },
  methods: {
    async addUpVote () {
      var response = await api.addVote(this.modelId, false)
      if (response.error) return
      this.localVoteCount += 1
      this.voteStatus = await api.getVoteStatus(this.modelId)
    },
    async addDownVote () {
      var response = await api.addVote(this.modelId, true)
      if (response.error) return
      this.localVoteCount -= 1
      this.voteStatus = await api.getVoteStatus(this.modelId)
    },
    async removeUpVote () {
      var response = await api.removeVote(this.modelId, false)
      if (response.error) return
      this.localVoteCount -= 1
      this.voteStatus = await api.getVoteStatus(this.modelId)
    },
    async removeDownVote () {
      var response = await api.removeVote(this.modelId, true)
      if (response.error) return
      this.localVoteCount += 1
      this.voteStatus = await api.getVoteStatus(this.modelId)
    }
  }
}
</script>

<style>

</style>
